#!/usr/bin/python

import random as rand
import sys

# parse input
njokes = 100
nusers = 1000
if len(sys.argv) > 1:
	nusers = int(sys.argv[1])
nround = 10
if len(sys.argv) > 2:
	nround = int(sys.argv[2])
outdir = 'ratings-{}'.format(nusers)
pctobs_train = 0.75
# pctobs_test = [.25,.35,.45,.55,.65,.75,1]
pctobs_test = [.25,.30,.35,.40,.45,.50,.55,.60,.65,.70,.75,1]

# seed random for deterministic splits
rand.seed(311)

''' Read the data '''
R = []
f = open('jester.csv','r')
line = f.readline()
while line != '':
	row = line.strip().split(',')
	nr = int(row[0])
	if nr == njokes:
		R_user = [(float(r)+10)/20 for r in row[1:(njokes+1)]]
# 		if len(R_user) != njokes:
# 			print 'Parsing error: incorrect number of ratings'
# 			exit()
		R.append(R_user)
	line = f.readline()
f.close()
# print 'Number of users: {0}'.format(len(R))

''' Randomly sample users '''
rand.shuffle(R)
R_train = R[0:nusers]
R_test = R[nusers:(2*nusers)]

''' Create training data '''
# pivot matrix to list
Rlist = [(u+1,i+1,R_train[u][i]) for u in range(nusers) for i in range(njokes)]
for round in range(nround):
	rand.shuffle(Rlist)
	nobs = int(pctobs_train * njokes * nusers)
	obs = Rlist[0:nobs]
	uno = Rlist[nobs:len(Rlist)]
	# write to files
	f = open('{}/jester-{}-tr-obs-{}.txt'.format(outdir,nusers,round),'w')
	for r in obs:
		f.write('{}\t{}\t{}\n'.format(r[0],r[1],r[2]))
	f.close()
	f = open('{}/jester-{}-tr-uno-{}.txt'.format(outdir,nusers,round),'w')
	for r in uno:
		f.write('{}\t{}\t{}\n'.format(r[0],r[1],r[2]))
	f.close()

''' Create testing data '''
# pivot matrix to list
Rlist = [(u+1,i+1,R_test[u][i]) for u in range(nusers) for i in range(njokes)]
for round in range(nround):
	rand.shuffle(Rlist)
	last_nobs = 0
	for epoch in range(len(pctobs_test)):
		nobs = int(pctobs_test[epoch] * njokes * nusers)
		obs = Rlist[last_nobs:nobs]
		# write to files
		f = open('{}/jester-{}-te-obs-{}-{}.txt'.format(outdir,nusers,round,epoch),'w')
		for r in obs:
			# Offset user ID by nusers so as not to clash with training users.
			f.write('{}\t{}\t{}\n'.format(r[0]+nusers,r[1],r[2]))
		f.close()
		last_nobs = nobs

